unit aliasweb;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, Db, DBTables,misock6,ComCtrls, StdCtrls;

type

  TGranPrimoDB = class (TGranprimo)
  private
    aliaslist_: TStringList;
    fOldConfigMode: TConfigMode;
    procedure InitBDE;
    procedure RestoreConfigMode;
    procedure SetConfigMode;

  public
      constructor Create(AOwner: TComponent); override;
      destructor  Destroy; override;
      // very important for GranPrimo extension
      function    extensionmenu(simple:boolean):string; override;
      procedure   LogAuto; override;
      //
      procedure aliased(rere:TmiResponserequest);
      procedure deletealias(rere:TmiResponserequest);
      procedure addaliased
        (rere:TmiResponserequest; const boton,accion:string);
      procedure selecTableEd(rere:TmiResponserequest);
      procedure addseetables
        (rere:TmiResponserequest; const boton,accion:string);
      procedure seetables(rere:TmiResponserequest);
      procedure VERtables(rere:TmiResponserequest);
      procedure selecverTables(rere:TmiResponserequest);
      procedure editaalias(rere:TmiResponserequest);
      procedure aliaspost(rere:TmiResponserequest);
      procedure delalias(rere:TmiResponserequest);
  end;


Function Intercambias (const cad,sts,por : string):string;
function ASCII_To_HTML(const Input: string): string;

implementation


procedure AmpFixup(var s: string);
var
   tmp : string;
   i   : integer;
begin
   tmp := '';
   for i := 1 to Length(s) do
      if s[i] = '&' then
         tmp := tmp + '&amp;'
      else tmp := tmp + s[i];
   s := tmp;
end;

Function Intercambias (const cad,sts,por : string):string;
Var i : integer;
    sc:string;
BEgin
  sc:=cad;
  if sts<>por then
  repeat
   i:=Pos (sts,sc);
   if i> 0 then
   Begin
    delete(sc,i,Length(sts));
    Insert(por,sc,i);
   end;
  until i=0;
  Intercambias:=sc;
end;

procedure FindReplace(var s: string; const Find, Replace: string);
begin
  s:=Intercambias (s,find,replace);
end;

function ASCII_To_HTML(const Input: string): string;
begin
   Result := Input;
   AmpFixup(Result);
   FindReplace(Result, '<', '&lt;');
   FindReplace(Result, '>', '&gt;');
   FindReplace(Result, '"', '&quot;');
end;


procedure TGranPrimodb.InitBDE;
begin
  if not(Session.Active) then
    Session.Active := True;
end;


procedure TGranPrimodb.RestoreConfigMode;
begin
  Session.ConfigMode := fOldConfigMode;
end;


procedure TGranPrimodb.SetConfigMode;
begin
  fOldConfigMode := Session.ConfigMode;
  Session.ConfigMode := cmPersistent;
end;


procedure TGranPrimodb.addaliased
        (rere:TmiResponserequest; const boton,accion:string);

procedure GetAliasList;
begin
  InitBDE;
  SetConfigMode;
  try
    Session.GetAliasNames(aliaslist_);
  finally
    RestoreConfigMode;
  end;
end;

var i:integer;
begin
  inithtm (rere,'Editor de alias');
  rere.Response.WriteContenido (
  ['<form name="galias"><p>Selecciona un alias<p>',
   '<select name="alias" size="5">']);
  GetAliasList;
  for i:=0 to aliaslist_.count-1 do
  rere.Response.WriteContenido
    (['<option ',i,' value="',accion,'?alias=',
      aliaslist_[i],'">',
      aliaslist_[i],'</option>']);
  rere.Response.WriteContenido (['</select>']);
  rere.Response.WriteContenido([
    '<input type="button" value="',boton,
    '" onClick="location=document.galias.alias.options[document.galias.alias.selectedIndex].value"></p>',
    '</form>']);
  DoneHtm (rere);
end;

procedure TGranPrimodb.deletealias(rere:TmiResponserequest);
begin
  addaliased (rere,'Delete','/deletealias.htm');
end;


procedure TGranPrimodb.aliased(rere:TmiResponserequest);
begin
  addaliased (rere,'Edit','/editaalias.htm');
end;

procedure TGranPrimodb.aliaspost(rere:TmiResponserequest);

var vals:TStringlist;
    i:integer;
    stt,st:string;


procedure DoEdit;
var
  ali: String;
  es:boolean;
begin
  ali := rere.request.Contenido.values['nombrealias'];
  InitBDE;
  SetConfigMode;
  try
   es:=Session.IsAlias(ali);
   if es then Session.ModifyAlias(ali, vals)
     else Session.AddAlias(ali, rere.request.Contenido.values['drv'], vals);
   Session.SaveConfigFile;
  finally
    RestoreConfigMode;
  end;
end;

begin
  vals:=Tstringlist.create;
  inithtm (rere,'ResultadoPost '+st);
  for i:=0 to rere.Request.Contenido.count -1 do
  begin
    st:=rere.request.Contenido[i];
    rere.response.WriteContenido( ['<p>',st,'</p>']);
  end;
  stt:=rere.request.Contenido.values['Descripcion'];
  vals.SetText( pchar(stt));
  doedit;
  donehtm (rere);
  vals.free;
end;

procedure TGranPrimodb.delalias(rere:TmiResponserequest);
begin
  InitBDE;
  SetConfigMode;
  try
    Session.DeleteAlias(rere.request.queryfields.values['alias']);
    Session.SaveConfigFile;
  finally
    RestoreConfigMode;
  end;
  aliased(rere);
end;


procedure TGranPrimodb.editaalias(rere:TmiResponserequest);
var an,ahora,driver_,st:string;
    memodrv,
    memo:TstringList;
    i:integer;
begin
  st:=rere.request.queryfields.Values['alias'];
  memo:=tstringlist.create;
  memodrv:=tstringlist.create;
  InitBDE;
  Session.GetDriverNames(memodrv);
  InitBDE;
  SetConfigMode;
  try
    Session.GetAliasParams(st,Memo);
    driver_:=Session.GetAliasDriverName(st);
  finally
    RestoreConfigMode;
  end;
  inithtm (rere,'Editando alias '+st);
  rere.Response.WriteContenido
  (['<form method="POST" action="/postalias.htm?alias=',st,'" name="galias"><p>Info alias<p>',
    'Alias <input type="text" name="nombrealias" size="20" Value="',st,'"></p>']);
  rere.Response.WriteContenido ([
   '<select name="drv" size="1">']);
  for i:=0 to memodrv.count-1 do
  begin
    ahora:=memodrv[i];
    if ahora=driver_ then an:='selected' else an:='';
    rere.Response.WriteContenido
    (['<option ',an,' value="',ahora,'">',ahora,'</option>']);
  end;
  rere.Response.WriteContenido (['</select>',
            '<TEXTAREA NAME="Descripcion" COLS="60" ROWS="5">',
            ASCII_TO_HTML (memo.Text),'</TEXTAREA><p>',
            ' <input type="submit" value="OK" name="B1"> ',
   '<P><A HREF="/delalias.htm?alias=',st,'"> delete ',st,'</A></P>',
    '</form>']);
  memodrv.free;
  memo.free;
  donehtm(rere);
end;


procedure TGranPrimodb.selecTableEd(rere:TmiResponserequest);
begin
  addaliased (rere,'tables','/seetables.htm');
end;

procedure TGranPrimodb.addseetables
        (rere:TmiResponserequest; const boton,accion:string);
var nombre:string;
    TableList:Tstringlist;
    i:integer;
begin
  TableList:=Tstringlist.create;
  nombre:=rere.request.QueryFields.Values['alias'];
  inithtm (rere,'Tablas de '+nombre);
  Session.GetTableNames(nombre,'', True, False, TableList);
  rere.Response.WriteContenido (
  ['<form name="galias"><p>Selecciona una tabla<p>',
   '<select name="alias" size="10">']);
  for i:=0 to tablelist.count-1 do
  rere.Response.WriteContenido
    (['<option ',i,' value="',accion,'?tabla=',
      tablelist[i],'&alias=',nombre,'">',
      tablelist[i],'</option>']);
  rere.Response.WriteContenido (['</select>']);
  rere.Response.WriteContenido([
    '<input type="button" value="',boton,
    '" onClick="location=document.galias.alias.options[document.galias.alias.selectedIndex].value"></p>',
    '</form>']);
  DoneHtm (rere);
  TableList.free;
end;

procedure TGranPrimodb.seetables(rere:TmiResponserequest);
begin
  addseetables (rere,'Edit','/edittable.htm');
end;

procedure TGranPrimodb.VERtables(rere:TmiResponserequest);
begin
  addseetables (rere,'Edit','/verlistatabla.htm');
end;

procedure TGranPrimodb.selecverTables(rere:TmiResponserequest);
begin
  addaliased (rere,'tables','/vertables.htm');
end;


procedure TGranPrimoDB.LogAuto;
var a:TmiWebActionItem;
begin
 inherited logauto;
 a:=Actions.Add;
 a.PathInfo:='/aliased.htm';
 a.OnAction:=aliased;
 a:=Actions.Add;
 a.PathInfo:='/editaalias.htm';
 a.OnAction:=editaalias;
 a:=Actions.Add;
 a.PathInfo:='/seetables.htm';
 a.OnAction:=seetables;
 a:=Actions.Add;
 a.PathInfo:='/selectable.htm';
 a.OnAction:=selecTableEd;
 a:=Actions.Add;
 a.PathInfo:='/vertables.htm';
 a.OnAction:=vertables;
 a:=Actions.Add;
 a.PathInfo:='/selecvertables.htm';
 a.OnAction:=selecvertables;
 a:=Actions.Add;
 a.PathInfo:='/postalias.htm';
 a.OnAction:=aliaspost;
 a:=Actions.Add;
 a.PathInfo:='/delalias.htm';
 a.OnAction:=delalias;
end;

constructor TGranPrimodb.Create(AOwner: TComponent);
begin
  inherited create (aowner);
  aliaslist_:= TStringList.Create;
end;

destructor TGranPrimodb.Destroy;
begin
  aliaslist_.Free;
  inherited Destroy;
end;

function    TGranPrimodb.extensionmenu(simple:boolean):string;
begin
  if simple then
  result:=cadenadevalores(
   ['<P></P>',
   '<P><A HREF="/aliased.htm">Editar Alias</A></P>',
   '<P><A HREF="/selectable.htm">Ver tablas</A></P>'
   ])
   else
  result:=cadenadevalores([
   'td_6 = "BDE Tables"',eol,
   'td_6_1 = "Alias Edit"',eol,
   'td_6_2 = "Tables Edit"',eol,
   'url_6_1 = "/aliased.htm"',eol,
   'url_6_2 = "/selectable.htm"',eol]);
end;


end.

